package com.eactive.eai.adapter.socket2.protocol.des.handshake;

import com.eactive.eai.adapter.socket2.config.SocketLoggerManager;
import com.eactive.eai.common.util.Logger;

import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.SecretKey;

public class DesCodec {
	Cipher ecipher;
	Cipher dcipher;
	private Logger logger = SocketLoggerManager.getInstance().getLogger();
	private static final String DES_CIPER = "DES";
	public DesCodec(SecretKey key) {
		try {
			ecipher = Cipher.getInstance(DES_CIPER);
			dcipher = Cipher.getInstance(DES_CIPER);
			ecipher.init(Cipher.ENCRYPT_MODE, key);
			dcipher.init(Cipher.DECRYPT_MODE, key);
		} catch (javax.crypto.NoSuchPaddingException e) {
			logger.info("NoSuchPaddingException"+ e.toString());
		} catch (java.security.NoSuchAlgorithmException e) {
			logger.info("NoSuchAlgorithmException"+ e.toString());
		} catch (java.security.InvalidKeyException e) {
			logger.info("InvalidKeyException"+ e.toString());
		}
	}

	public byte[] encrypt(byte[] utf8) {
		try {
			// Encode the string into bytes using utf-8
			//byte[] utf8 = str.getBytes("UTF8");
			// Encrypt
//			byte[] enc = ecipher.doFinal(utf8);
			// Encode bytes to base64 to get a string				
			//return new sun.misc.BASE64Encoder().encode(enc);
			return ecipher.doFinal(utf8);
		} catch (javax.crypto.BadPaddingException e) {
			logger.info("BadPaddingException - "+ e.toString());
		} catch (IllegalBlockSizeException e) {
			logger.info("IllegalBlockSizeException - "+ e.toString());
		}
		return null;
	}

	public byte[] decrypt(byte[] dec) {
		try {
			// Decode base64 to get bytes
			//byte[] dec = new sun.misc.BASE64Decoder().decodeBuffer(str);

			// Decrypt
//			byte[] utf8 = dcipher.doFinal(dec);
			// Decode using utf-8
//			return new String(utf8, "UTF8");
			return dcipher.doFinal(dec);
		} catch (javax.crypto.BadPaddingException e) {
			logger.info("BadPaddingException - "+ e.toString());
		} catch (IllegalBlockSizeException e) {
			logger.info("IllegalBlockSizeException - "+ e.toString());
		}
		return null;
	}
}
